﻿/*
====== READ THIS ========
This code was created as a part of the seminar on 
flash game programing at the University of Munich (Ludwig-
Maximlians Universität.

The code may be used for educational purposes only. All
rights reserverd by the author.

Author: Max Maurer
E-Mail: max.maurer@ifi.lmu.de
(c) 2011
If you have any questions don't hasitate to contact me.
=========================
*/
package {
	import flash.display.MovieClip;
	
	public class Ball extends MovieClip {
		public static const BALL_INCREASE:Number = .005;
		public static const DEG:Number = Math.PI/180;
		public var ballSpeed:Number;
		public function Ball():void {
			rotation=Math.random()*360;
			ballSpeed=8;
		}
		
		public function move():void {
			ballSpeed+=BALL_INCREASE;
			x += Math.cos(rotation*DEG)*ballSpeed;
			y += Math.sin(rotation*DEG)*ballSpeed;
			// check collissions
			if (x<0) {
				rotation=-rotation+180;
				x=0;
				dispatchEvent(new BallEvent(BallEvent.SCORED, 0));
			}
			if (x>stage.stageWidth) {
				rotation=-rotation+180;
				x=stage.stageWidth;
				dispatchEvent(new BallEvent(BallEvent.SCORED, 1));
			}
			if (y>stage.stageHeight) {
				y=stage.stageHeight;
				rotation=-rotation;
			}
			if (y<0) {
				y=0;
				rotation=-rotation;
			}
		}
		
		public function checkPaddleCollision(paddle:MovieClip):void {
			if (x>paddle.x-paddle.width/2 && x<paddle.x+paddle.width/2 && y>paddle.y-paddle.height/2 && y<paddle.y+paddle.height/2) {
				rotation=-rotation+180;
			}
		}
	}
}